regina::ProgressTracker Class Reference
Progress Tracking

Manages percentage-based progress tracking and cancellation polling for long operations. More...

`#include <progress/progresstracker.h>`

Inheritance diagram for regina::ProgressTracker:

## Public Member Functions

| ProgressTracker ()
| Creates a new progress tracker. More...
bool | percentChanged ()
| Queries whether the percentage progress has changed since the last call to percentChanged(). More...
double | percent ()
| Returns the percentage progress through the entire operation. More...
void | newStage (const char *desc, double weight=1)
| Used by the writing thread to indicate that it has moved on to a new stage of processing. More...
void | newStage (const std::string &desc, double weight=1)
| Used by the writing thread to indicate that it has moved on to a new stage of processing. More...
bool | setPercent (double percent)
| Used by the writing thread to indicate the level of progress through the current stage. More...
void | setFinished ()
| Used by the writing thread to indicate that it has finished all processing. More...
bool | isFinished ()
| Queries whether the writing thread has finished all processing. More...
bool | descriptionChanged ()
| Queries whether the stage description has changed since the last call to descriptionChanged(). More...
std::string | description ()
| Returns the human-readable description of the current stage. More...
void | cancel ()
| Indicates to the writing thread that the user wishes to cancel the operation. More...
bool | isCancelled ()
| Queries whether the reading thread has made a request for the writing thread to cancel the operation; in other words, whether cancel() has been called. More...

## Protected Attributes

std::string | desc_
| The human-readable description of the current stage. More...
bool | descChanged_
| Has the description changed since the last call to descriptionChanged()? More...
bool | cancelled_
| Has the reading thread requested that the operation be cancelled? More...
bool | finished_
| Has the writing thread declared that it has finished all processing? More...
std::mutex | lock_
| A mutex to stop the reading and writing threads from interfering with each other. More...

## Detailed Description

Manages percentage-based progress tracking and cancellation polling for long operations.

See the ProgressTrackerBase documentation for detailed information on how to use a progress tracker.

This class represents a progress tracker that measures progress using percentages. Specifically, each stage has a percentage progress that rises from 0 to 100 as the stage progresses. Each stage also has a fractional weight (between 0 and 1 inclusive), and the percentage progress of the entire calculation is taken to be the weighted sum of the progress of the individual stages. The weights of all stages should sum to 1.

## Constructor & Destructor Documentation

## ProgressTracker()

regina::ProgressTracker::ProgressTracker | ( |  | ) |

inline

Creates a new progress tracker.

This sets a sensible state description (which declares that the operation is initialising), and marks the current progress as zero percent complete.

This is typically called by the reading thread.

## Member Function Documentation

## cancel()

void regina::ProgressTrackerBase::cancel | ( |  | ) |

inline inherited

Indicates to the writing thread that the user wishes to cancel the operation.

The writing thread might not detect and/or respond to this request immediately (or indeed ever), and so the reading thread should continue to wait until isFinished() returns `true` before it cleans up and destroys this progress tracker.

This is typically called by the reading thread.

## description()

std::string regina::ProgressTrackerBase::description | ( |  | ) |

inline inherited

Returns the human-readable description of the current stage.

This is typically called by the reading thread.

Returns
  `the` current stage description.

## descriptionChanged()

bool regina::ProgressTrackerBase::descriptionChanged | ( |  | ) |

inline inherited

Queries whether the stage description has changed since the last call to descriptionChanged().

If this is the first time descriptionChanged() is called, the result will be `true`.

This is typically called by the reading thread.

Returns
  `true` if and only if the stage description has changed.

## isCancelled()

bool regina::ProgressTrackerBase::isCancelled | ( |  | ) |

inline inherited

Queries whether the reading thread has made a request for the writing thread to cancel the operation; in other words, whether cancel() has been called.

This is typically called by the writing thread.

Returns
  `true` if and only if a cancellation request has been made.

## isFinished()

bool regina::ProgressTrackerBase::isFinished | ( |  | ) |

inline inherited

Queries whether the writing thread has finished all processing.

This will eventually return `true` regardless of whether the processing finished naturally or was cancelled by the reading thread.

This is typically called by the reading thread.

Returns
  `true` if and only if the writing thread has finished all processing.

## newStage() [1/2]

void regina::ProgressTracker::newStage | ( | const char * | desc,
|  | double | weight = `1`
| ) |  |

inline

Used by the writing thread to indicate that it has moved on to a new stage of processing.

The percentage progress through the current stage will automatically be set to 100.

This is typically called by the writing thread.

Parameters

  desc | a human-readable description of the new stage. Typically this begins with a capital and does not include a final period (full stop).
  weight | the relative weight of this stage as a fraction of the entire operation. This weight must be between 0 and 1 inclusive, and the weights of all stages must sum to 1 in total.

## newStage() [2/2]

void regina::ProgressTracker::newStage | ( | const std::string & | desc,
|  | double | weight = `1`
| ) |  |

inline

Used by the writing thread to indicate that it has moved on to a new stage of processing.

The percentage progress through the current stage will automatically be set to 100.

This is typically called by the writing thread.

Parameters

  desc | a human-readable description of the new stage. Typically this begins with a capital and does not include a final period (full stop).
  weight | the relative weight of this stage as a fraction of the entire operation. This weight must be between 0 and 1 inclusive, and the weights of all stages must sum to 1 in total.

## percent()

double regina::ProgressTracker::percent | ( |  | ) |

inline

Returns the percentage progress through the entire operation.

This combines the progress through the current stage with all previous stages, taking into account the relative weights that the writing thread has passed to newStage().

This is typically called by the reading thread.

Returns
  the current percentage progress.

## percentChanged()

bool regina::ProgressTracker::percentChanged | ( |  | ) |

inline

Queries whether the percentage progress has changed since the last call to percentChanged().

If this is the first time percentChanged() is called, the result will be `true`.

This is typically called by the reading thread.

Returns
  `true` if and only if the percentage progress has changed.

## setFinished()

void regina::ProgressTracker::setFinished | ( |  | ) |

inline

Used by the writing thread to indicate that it has finished all processing.

The percentage progress through both the current stage and the entire operation will automatically be set to 100, and the stage description will be updated to indicate that the operation is finished.

This is typically called by the writing thread.

## setPercent()

bool regina::ProgressTracker::setPercent | ( | double | percent | ) |

inline

Used by the writing thread to indicate the level of progress through the current stage.

Unlike percent(), which measures progress in the context of the entire operation, this routine takes a percentage that is strictly relative to the current stage (i.e., the stage most recently declared through a call to newStage()). When the stage begins, setPercent() would typically be given a figure close to 0; when the stage is finished, setPercent() would typically be given a figure close to 100.

There is no actual need to call setPercent(0) at the beginning of the stage or setPercent(100) at the end of the stage, since other routines (such as the constructor, newStage() and setFinished()) will take care of this for you.

This is typically called by the writing thread.

Parameters

  percent | the percentage progress through this stage, as a number between 0 and 100 inclusive.

Returns
  `true` if there has been no cancellation request, or `false` if cancel() has been called (typically by the reading thread).

## Member Data Documentation

## cancelled_

bool regina::ProgressTrackerBase::cancelled_

protected inherited

Has the reading thread requested that the operation be cancelled?

## desc_

std::string regina::ProgressTrackerBase::desc_

protected inherited

The human-readable description of the current stage.

## descChanged_

bool regina::ProgressTrackerBase::descChanged_

protected inherited

Has the description changed since the last call to descriptionChanged()?

## finished_

bool regina::ProgressTrackerBase::finished_

protected inherited

Has the writing thread declared that it has finished all processing?

## lock_

std::mutex regina::ProgressTrackerBase::lock_

protected inherited

A mutex to stop the reading and writing threads from interfering with each other.

The documentation for this class was generated from the following file:

- progress/progresstracker.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).